/** A ConfigurationList is a linked list of configurations.  It also has the
    ability to search for a given configuration. */

public class ConfigurationList
{
    Configuration       config;
    ConfigurationList   next;


    /** Make a new ConfigurationList node. */

    public ConfigurationList(Configuration c, ConfigurationList cl)
    {
        config = c;
        next = cl;
    }
                                                

    /** Is there a configuration in the queue matching a given configuration? */

    boolean isPresent(Configuration match)
    {
        for (ConfigurationList cl = this; cl != null; cl = cl.next)
            if (cl.config.equals(match))
                return true;
                
        return false;
    }
}
