
/** A Queue is a linked list implementation of a queue, used for BFS.  */

public class Queue
{
    ConfigurationList   head;               // the configuration that will be dequeued next
    ConfigurationList   tail;               // the configuration that was last enqueued
    
    static int          inserts;
                            
    /** Add config to the queue. */

    public void enqueue(Configuration config)
    {
        ConfigurationList cl = new ConfigurationList(config, null);
        
        if (head == null)
            head = tail = cl;                   // it's empty
        else
        {
            tail.next = cl;     
            tail = cl;
        }
        
        // simple progress indicator
    
        if ((++inserts % 1000) == 0)
        {
            System.out.write('.');
            System.out.flush();
        }
    }
    
    /** Remove & return the head of the queue. */
    
    Configuration dequeue()
    {
        Configuration result = head.config;
        head = head.next;
            
        return result;
    }


    /** Is the queue empty? */

    boolean empty()
    {
        return head == null;
    }
    
    
    /** Is there a configuration in the queue matching a given configuration? */

    boolean isPresent(Configuration match)
    {
        return !empty() && head.isPresent(match);
    }
};
